SystemOrganization addCategory: #'A4BP-core'!
SystemOrganization addCategory: 'A4BP-core-model'!
SystemOrganization addCategory: 'A4BP-core-parser'!

MooseEntity subclass: #A4BPObject
	instanceVariableNames: 'aName parent childrens text myDocument'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'A4BP-core-model'!

A4BPObject subclass: #A4BPEmptyObj
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'A4BP-core-model'!

A4BPEmptyObj class
	instanceVariableNames: 'instance'!

A4BPEmptyObj class
	instanceVariableNames: 'instance'!

!A4BPEmptyObj class methodsFor: 'instance' stamp: 'AlvaroJosePeraltaOcampo 11/19/2014 00:28'!
annotation
	<MSEClass: #BPEmtyObj super: #BPObject>
	<package: #BpelAnalyzer>! !

!A4BPEmptyObj class methodsFor: 'builder' stamp: 'AlvaroJosePeraltaOcampo 11/19/2014 00:28'!
fromXMLDescription: docAtr in: aBPObject
	^ super fromXMLDescription: docAtr in: aBPObject! !

!A4BPEmptyObj class methodsFor: 'instance' stamp: 'AlvaroJosePeraltaOcampo 11/19/2014 00:28'!
instance
	instance ifNil:[instance:=self new].
	instance aName:'BPEmptyObj'.
	^ instance! !

!A4BPEmptyObj methodsFor: 'all' stamp: 'AlvaroJosePeraltaOcampo 11/19/2014 00:28'!
allElements
	^ OrderedCollection new! !

!A4BPEmptyObj methodsFor: 'as yet unclassified' stamp: 'AlvaroJosePeraltaOcampo 11/19/2014 00:28'!
bpwsdl
	^ nil! !

!A4BPEmptyObj methodsFor: 'as yet unclassified' stamp: 'AlvaroJosePeraltaOcampo 11/19/2014 00:28'!
getChildrenNodes
	^ nil! !

!A4BPEmptyObj methodsFor: 'initialization' stamp: 'AlvaroJosePeraltaOcampo 11/19/2014 00:28'!
initialize
	super initialize.
	aName:='Empty'.! !

!A4BPEmptyObj methodsFor: 'as yet unclassified' stamp: 'AlvaroJosePeraltaOcampo 11/19/2014 00:28'!
isBPEmtyObj
 ^ true! !

!A4BPEmptyObj methodsFor: 'all' stamp: 'AlvaroJosePeraltaOcampo 11/19/2014 00:28'!
link
	^ self! !

!A4BPObject class methodsFor: 'meta' stamp: 'AlvaroJosePeraltaOcampo 11/11/2014 18:07'!
annotation
	<abstract>
	<MSEClass: #BPObject super: #Object>
	<package: #BpelAnalyzer>! !

!A4BPObject class methodsFor: 'doForAllChield' stamp: 'AlvaroJosePeraltaOcampo 11/11/2014 18:07'!
fillBData: document in: aBPObject
	aBPObject myDocument:document.
	aBPObject aName: (self readName: document).
	aBPObject text: document asString.
	^ aBPObject! !

!A4BPObject class methodsFor: 'doForAllChield' stamp: 'AlvaroJosePeraltaOcampo 11/11/2014 18:07'!
fillElementsIn: aBPObj from: document
	^ aBPObj ! !

!A4BPObject class methodsFor: 'doForAllChield' stamp: 'AlvaroJosePeraltaOcampo 11/11/2014 18:07'!
fillElementsIn: aBPObject from: document visitor: visitor
	self
		fillElementsIn: aBPObject
		from: document
		visitor: visitor
		tagRef: BPParserTagsXMLRef! !

!A4BPObject class methodsFor: 'doForAllChield' stamp: 'AlvaroJosePeraltaOcampo 11/11/2014 18:07'!
fillElementsIn: aBPObject from: document visitor: visitor tagRef: aTagRef
	| bpElement refTag typeName nodes |
	nodes := document nodes.
	nodes
		do: [ :docAtr | 
			typeName := docAtr name.
			refTag := aTagRef getClassBPBaseOnTypeName: typeName.
			bpElement := refTag objclass fromXMLDescription: docAtr in: aBPObject.
			bpElement accept: visitor ]! !

!A4BPObject class methodsFor: 'parser' stamp: 'AlvaroJosePeraltaOcampo 11/11/2014 18:07'!
fromXMLDescription: document
	| obj |
	obj := self new.
	self fillBData: document in: obj.
	self fillElementsIn: obj from: document.
	^ obj! !

!A4BPObject class methodsFor: 'parser' stamp: 'AlvaroJosePeraltaOcampo 11/11/2014 18:07'!
fromXMLDescription: document in: parent
	| aBPObj |
	aBPObj := self new.
	aBPObj parent: parent.
	self fillBData: document in: aBPObj.
	self fillElementsIn: aBPObj from: document.
	^ aBPObj! !

!A4BPObject class methodsFor: 'parser' stamp: 'AlvaroJosePeraltaOcampo 11/11/2014 18:07'!
readArt: document at: tag
	^ [ document attributeAt: tag ]
		on: MessageNotUnderstood
		do: [ ^ document asString ]! !

!A4BPObject class methodsFor: 'parser' stamp: 'AlvaroJosePeraltaOcampo 11/26/2014 05:43'!
readBoolean: document at: tag
	^ [ (document attributeAt: tag) = 'true']
		on: MessageNotUnderstood
		do: [ ^ false ]! !

!A4BPObject class methodsFor: 'doForAllChield' stamp: 'AlvaroJosePeraltaOcampo 11/11/2014 18:07'!
readName: document
	^ [ document attributeAt: BPParserTagsXMLRef atrName ]
		on: MessageNotUnderstood
		do: [ ^ document asString ]! !

!A4BPObject methodsFor: 'getset' stamp: 'AlvaroJosePeraltaOcampo 11/11/2014 18:07'!
aName
	^ aName! !

!A4BPObject methodsFor: 'getset' stamp: 'AlvaroJosePeraltaOcampo 11/11/2014 18:07'!
aName: pname
	aName := pname! !

!A4BPObject methodsFor: 'visitor' stamp: 'AlvaroJosePeraltaOcampo 11/26/2014 05:23'!
accept: aVisitor
	^ aVisitor visitBPMN20ProcessImpl: self! !

!A4BPObject methodsFor: 'doNothing' stamp: 'AlvaroJosePeraltaOcampo 11/11/2014 18:07'!
addActivity: aBPActivity! !

!A4BPObject methodsFor: 'getset' stamp: 'AlvaroJosePeraltaOcampo 11/11/2014 18:07'!
addChildren: aModel
	self childrens add:aModel.! !

!A4BPObject methodsFor: 'doNothing' stamp: 'AlvaroJosePeraltaOcampo 11/11/2014 18:07'!
addRelation: aRel! !

!A4BPObject methodsFor: 'getset' stamp: 'AlvaroJosePeraltaOcampo 11/11/2014 18:07'!
allNodes
	|lst|
	lst:=OrderedCollection new.
	lst addAll:self childrens.
	self childrens do:[ :e| lst addAll: e allNodes ].
	^ lst.! !

!A4BPObject methodsFor: 'doNothing' stamp: 'AlvaroJosePeraltaOcampo 11/11/2014 18:07'!
allRelations
	^ OrderedCollection new! !

!A4BPObject methodsFor: 'getset' stamp: 'AlvaroJosePeraltaOcampo 11/11/2014 18:07'!
asString
	"
	^ aName , '[', self hash asString,'],',super asString.
	"
	^ self aName! !

!A4BPObject methodsFor: 'metric' stamp: 'AlvaroJosePeraltaOcampo 11/11/2014 18:07'!
calculateCFC
	| metric visitor |
	metric := 0.
	visitor := BPMetricCFC new.
	metric := self accept: visitor.
	^ metric! !

!A4BPObject methodsFor: 'getset' stamp: 'AlvaroJosePeraltaOcampo 11/11/2014 18:07'!
childrens
	"leazy initialization"
	^ childrens ifNil:[childrens:=OrderedCollection new].! !

!A4BPObject methodsFor: 'getset' stamp: 'AlvaroJosePeraltaOcampo 11/11/2014 18:07'!
childrens: aCollection
	childrens := aCollection! !

!A4BPObject methodsFor: 'getset' stamp: 'AlvaroJosePeraltaOcampo 11/11/2014 18:07'!
cnodes
	^ self childrens ! !

!A4BPObject methodsFor: 'getset' stamp: 'AlvaroJosePeraltaOcampo 11/11/2014 18:07'!
getChildrenNodes
	^ self childrens ! !

!A4BPObject methodsFor: 'initialization' stamp: 'AlvaroJosePeraltaOcampo 11/11/2014 18:07'!
initialize
	aName := ''! !

!A4BPObject methodsFor: 'getset' stamp: 'AlvaroJosePeraltaOcampo 11/11/2014 18:07'!
isBPEmtyObj
 ^ false! !

!A4BPObject methodsFor: 'getset' stamp: 'AlvaroJosePeraltaOcampo 11/11/2014 18:07'!
key
	^ aName! !

!A4BPObject methodsFor: 'getset' stamp: 'AlvaroJosePeraltaOcampo 11/11/2014 18:07'!
label
	^ self aName! !

!A4BPObject methodsFor: 'moose' stamp: 'AlvaroJosePeraltaOcampo 11/25/2014 19:52'!
mooseNameOn: aStream 
	aStream nextPutAll: self aName! !

!A4BPObject methodsFor: 'getset' stamp: 'AlvaroJosePeraltaOcampo 11/11/2014 18:07'!
myDocument
	^ myDocument! !

!A4BPObject methodsFor: 'getset' stamp: 'AlvaroJosePeraltaOcampo 11/11/2014 18:07'!
myDocument: document
	myDocument := document! !

!A4BPObject methodsFor: 'getset' stamp: 'AlvaroJosePeraltaOcampo 11/11/2014 18:07'!
name
	^ self aName! !

!A4BPObject methodsFor: 'getset' stamp: 'AlvaroJosePeraltaOcampo 11/11/2014 18:07'!
parent
	^ parent! !

!A4BPObject methodsFor: 'getset' stamp: 'AlvaroJosePeraltaOcampo 11/11/2014 18:07'!
parent: aModel
	parent
		ifNil: [ 
			parent := aModel.
			parent addChildren: self ]! !

!A4BPObject methodsFor: 'metric' stamp: 'AlvaroJosePeraltaOcampo 11/11/2014 18:07'!
size
	^ 1! !

!A4BPObject methodsFor: 'getset' stamp: 'AlvaroJosePeraltaOcampo 11/11/2014 18:07'!
text
	^ text! !

!A4BPObject methodsFor: 'getset' stamp: 'AlvaroJosePeraltaOcampo 11/11/2014 18:07'!
text: aText
	text := aText! !

!A4BPObject methodsFor: 'as yet unclassified' stamp: 'AlvaroJosePeraltaOcampo 11/11/2014 18:07'!
xml
	myDocument ifNotNil: [ ^ myDocument parser asString ].
	^ ''! !

A4BPObject subclass: #A4BPSOAAnalyzer
	instanceVariableNames: 'lstSOAContext'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'A4BP-core-model'!

A4BPSOAAnalyzer class
	instanceVariableNames: 'instance'!

A4BPSOAAnalyzer class
	instanceVariableNames: 'instance'!

!A4BPSOAAnalyzer class methodsFor: 'singleton' stamp: 'AlvaroJosePeraltaOcampo 11/11/2014 18:12'!
instance
	instance ifNil: [ instance := self new ].
	^ instance! !

!A4BPSOAAnalyzer class methodsFor: 'singleton' stamp: 'AlvaroJosePeraltaOcampo 11/11/2014 18:12'!
reset
	instance := nil.
	^ 'OK'! !

!A4BPSOAAnalyzer methodsFor: 'visitor' stamp: 'AlvaroJosePeraltaOcampo 11/11/2014 18:12'!
accept: aVisitor
	^ aVisitor visitSOAAnalyzer:self.! !

!A4BPSOAAnalyzer methodsFor: 'action' stamp: 'AlvaroJosePeraltaOcampo 11/11/2014 18:12'!
addSOAContext: aSOAContext
	lstSOAContext at: aSOAContext key put: aSOAContext! !

!A4BPSOAAnalyzer methodsFor: 'action' stamp: 'AlvaroJosePeraltaOcampo 11/11/2014 18:12'!
deleteSOAContext: aSOAContext
	lstSOAContext removeKey: aSOAContext key.! !

!A4BPSOAAnalyzer methodsFor: 'getset' stamp: 'AlvaroJosePeraltaOcampo 11/11/2014 18:12'!
getChildrenNodes
	^ self lstSOAContext ! !

!A4BPSOAAnalyzer methodsFor: 'initialization' stamp: 'AlvaroJosePeraltaOcampo 11/11/2014 18:12'!
initialize
	super initialize.
	aName:='SOAAnalyzer'.
	lstSOAContext := Dictionary new! !

!A4BPSOAAnalyzer methodsFor: 'getset' stamp: 'AlvaroJosePeraltaOcampo 11/11/2014 18:12'!
lstSOAContext
	^ lstSOAContext ! !

!A4BPSOAAnalyzer methodsFor: 'getset' stamp: 'AlvaroJosePeraltaOcampo 11/11/2014 18:12'!
name
	^ 'Root>', self hash asString! !

!A4BPSOAAnalyzer methodsFor: 'getset' stamp: 'AlvaroJosePeraltaOcampo 11/11/2014 18:12'!
soaContexts
	^ self lstSOAContext  ! !

A4BPObject subclass: #A4BPSOAContext
	instanceVariableNames: 'lstBPProcess lstBPWSDLs key lstBPXSDSchema lstBPMN lstBPMN20'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'A4BP-core-model'!

!A4BPSOAContext class methodsFor: 'as yet unclassified' stamp: 'AlvaroJosePeraltaOcampo 11/11/2014 18:15'!
createBaseOnPath: aPath
	| aNewSOAContext |
	aNewSOAContext := self new.
	aNewSOAContext createBaseOnPath: aPath.
	^ aNewSOAContext! !

!A4BPSOAContext methodsFor: 'visitor' stamp: 'AlvaroJosePeraltaOcampo 11/26/2014 15:18'!
accept: aVisitor
	^ aVisitor visitA4BPSOAContext: self! !

!A4BPSOAContext methodsFor: 'add' stamp: 'AlvaroJosePeraltaOcampo 11/11/2014 18:12'!
addAllBPMN: lst
	lst do: [ :w | lstBPMN at: w hash put: w ]! !

!A4BPSOAContext methodsFor: 'add' stamp: 'AlvaroJosePeraltaOcampo 11/11/2014 18:12'!
addBPProcess: lst
	lst
		do: [ :p | 
			lstBPProcess at: p aName put: p.
			p parent: self ]! !

!A4BPSOAContext methodsFor: 'add' stamp: 'AlvaroJosePeraltaOcampo 11/11/2014 18:12'!
addBPWSDLs: lst
	lst do: [ :w | lstBPWSDLs at: w aName put: w ]! !

!A4BPSOAContext methodsFor: 'add' stamp: 'AlvaroJosePeraltaOcampo 11/11/2014 18:12'!
addBPXSDSchemas: lst
	lst do: [ :xsd | lstBPXSDSchema at: xsd aName put: xsd ]! !

!A4BPSOAContext methodsFor: 'add' stamp: 'AlvaroJosePeraltaOcampo 11/19/2014 10:44'!
addProcessBPMN20: lst
	lst
		do: [ :p | 
			lstBPMN20 at: p aName put: p.
			p parent: self ]! !

!A4BPSOAContext methodsFor: 'getset' stamp: 'AlvaroJosePeraltaOcampo 11/11/2014 18:12'!
allBPProcess
	^ lstBPProcess ! !

!A4BPSOAContext methodsFor: 'getset' stamp: 'AlvaroJosePeraltaOcampo 11/11/2014 18:12'!
allBPWSDL
	^ lstBPWSDLs! !

!A4BPSOAContext methodsFor: 'creator' stamp: 'AlvaroJosePeraltaOcampo 11/11/2014 18:12'!
buildRelations
	"Build relations for each process in all WSDL"
	lstBPProcess copy do: [ :p | lstBPWSDLs do: [ :wsdl | p buildRelations: wsdl ] ].
	"Build relations for each process in all Process"
	lstBPProcess copy do: [ :pa | lstBPProcess do: [ :pb | pa buildRelations: pb ] ].
	"Build relations for each process in all XSD".
	lstBPProcess copy do: [ :pa | lstBPXSDSchema do: [ :xsd | pa buildRelations: xsd ] ].
	"Build relatinos for each wsld in all XSD"
	lstBPWSDLs copy do: [ :wsdl | lstBPXSDSchema do: [ :xsd | wsdl buildRelations: xsd ] ].
			
! !

!A4BPSOAContext methodsFor: 'creator' stamp: 'AlvaroJosePeraltaOcampo 11/27/2014 08:06'!
createBaseOnPath: aString
	"create a soa world base on path of file system"
	| afr files parsers |
	afr := aString asFileReference.
	parsers := OrderedCollection new.
	parsers add: BPMN20Parser new.
	parsers
		do: [ :parser | 
			files := afr allFiles select: [ :each | each basename endsWith: parser filePrefix ].
			files do: [ :file | parser parseFile: file ].
			parser addInContext: self.
			].
	self buildRelations! !

!A4BPSOAContext methodsFor: 'getset' stamp: 'AlvaroJosePeraltaOcampo 11/11/2014 18:12'!
getBPProcessAtName: pName
	[ ^ lstBPProcess at: pName ]
		on: KeyNotFound
		do: [ ^ BPEmptyObj instance ]! !

!A4BPSOAContext methodsFor: 'getset' stamp: 'AlvaroJosePeraltaOcampo 11/11/2014 18:12'!
getBPWSDLAtName: pName
	[ ^ lstBPWSDLs at: pName ]
		on: KeyNotFound
		do: [ ^ BPEmptyObj instance ]! !

!A4BPSOAContext methodsFor: 'getset' stamp: 'AlvaroJosePeraltaOcampo 11/11/2014 18:12'!
getBPXSDAtName: pName
	[ ^ lstBPWSDLs at: pName ]
		on: KeyNotFound
		do: [ ^ BPEmptyObj instance ]! !

!A4BPSOAContext methodsFor: 'getset' stamp: 'AlvaroJosePeraltaOcampo 11/26/2014 14:36'!
getChildrenNodes
	| newCollection |
	newCollection := OrderedCollection new.
	newCollection addAll: lstBPProcess.
	newCollection addAll: lstBPWSDLs.
	newCollection addAll: lstBPXSDSchema.
	newCollection addAll: lstBPMN20.
	
	^ newCollection! !

!A4BPSOAContext methodsFor: 'initialization' stamp: 'AlvaroJosePeraltaOcampo 11/19/2014 10:44'!
initialize
	super initialize.
	lstBPProcess := Dictionary new.
	lstBPWSDLs := Dictionary new.
	lstBPXSDSchema :=Dictionary new.
	lstBPMN:=Dictionary new.
	lstBPMN20:=Dictionary new.
	aName := self hash asString! !

!A4BPSOAContext methodsFor: 'getset' stamp: 'AlvaroJosePeraltaOcampo 11/11/2014 18:12'!
key
	key ifNil: [ ^ self hash ].
	^ key! !

!A4BPSOAContext methodsFor: 'getset' stamp: 'AlvaroJosePeraltaOcampo 11/11/2014 18:12'!
key:aKey
	key:=aKey! !

!A4BPSOAContext methodsFor: 'getset' stamp: 'AlvaroJosePeraltaOcampo 11/11/2014 18:12'!
label
	^ self aName! !

!A4BPSOAContext methodsFor: 'getset' stamp: 'AlvaroJosePeraltaOcampo 11/19/2014 10:59'!
lstBPMN20
	^ lstBPMN20 ! !

!A4BPSOAContext methodsFor: 'getset' stamp: 'AlvaroJosePeraltaOcampo 11/11/2014 18:12'!
lstBPProcess
	^ lstBPProcess ! !

!A4BPSOAContext methodsFor: 'getset' stamp: 'AlvaroJosePeraltaOcampo 11/11/2014 18:12'!
lstBPWSDLs
	^ lstBPWSDLs! !

!A4BPSOAContext methodsFor: 'getset' stamp: 'AlvaroJosePeraltaOcampo 11/11/2014 18:12'!
lstBPXSDSchema
	^ lstBPXSDSchema ! !

!A4BPSOAContext methodsFor: 'getset' stamp: 'AlvaroJosePeraltaOcampo 11/11/2014 18:12'!
name
	^ 'SOAContext>',self hash asString! !

!A4BPSOAContext methodsFor: 'metrics' stamp: 'AlvaroJosePeraltaOcampo 11/11/2014 18:12'!
numberOfProcess
	^ lstBPProcess size.! !

!A4BPSOAContext methodsFor: 'metrics' stamp: 'AlvaroJosePeraltaOcampo 11/11/2014 18:12'!
numberOfSchemas
	^ lstBPXSDSchema size.! !

!A4BPSOAContext methodsFor: 'metrics' stamp: 'AlvaroJosePeraltaOcampo 11/11/2014 18:12'!
numberOfWSDLs
	^ lstBPWSDLs size.! !

Object subclass: #A4BPAbstractParser
	instanceVariableNames: 'lstElements'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'A4BP-core-parser'!

!A4BPAbstractParser class methodsFor: 'parser' stamp: 'AlvaroJosePeraltaOcampo 11/11/2014 18:48'!
parseString: string
	^ self new parseString: string! !

!A4BPAbstractParser methodsFor: 'adding' stamp: 'AlvaroJosePeraltaOcampo 11/11/2014 18:48'!
addElement: aElement
	lstElements add: aElement! !

!A4BPAbstractParser methodsFor: 'getset' stamp: 'AlvaroJosePeraltaOcampo 11/12/2014 09:57'!
elements
	^ self lstElements! !

!A4BPAbstractParser methodsFor: 'abstract' stamp: 'AlvaroJosePeraltaOcampo 11/11/2014 18:48'!
getBaseElement
	^ BPEmptyObj ! !

!A4BPAbstractParser methodsFor: 'getset' stamp: 'AlvaroJosePeraltaOcampo 11/11/2014 18:48'!
getDocumentBaseOnStream: aStream
	"return the object to be parser"
	| document |
	document := BPFactoryXMLParser parser parse: aStream.
	^ document! !

!A4BPAbstractParser methodsFor: 'initialization' stamp: 'AlvaroJosePeraltaOcampo 11/11/2014 18:48'!
initialize
	super initialize.
	lstElements := OrderedCollection new! !

!A4BPAbstractParser methodsFor: 'getset' stamp: 'AlvaroJosePeraltaOcampo 11/11/2014 18:48'!
lstElements
	^ lstElements! !

!A4BPAbstractParser methodsFor: 'abstract' stamp: 'AlvaroJosePeraltaOcampo 11/11/2014 18:48'!
lstOfTag
	^ OrderedCollection new.! !

!A4BPAbstractParser methodsFor: 'metric' stamp: 'AlvaroJosePeraltaOcampo 11/11/2014 18:48'!
numberOfElements
	^ self lstElements size.! !

!A4BPAbstractParser methodsFor: 'parser' stamp: 'AlvaroJosePeraltaOcampo 11/27/2014 07:52'!
parseFile: aFile
	"base on stream object the stream create BPObjets to represent the xml in memory"
	[  
	
	aFile
		readStreamDo: [ :stream | 
			| document eXml |
			"Start creating a XMLDOM Object from stream"
			document := self getDocumentBaseOnStream: stream.
			self lstOfTag
				do: [ :tag | 
					BPLog f:' start with tags:',tag.
					eXml := document allElementsNamed: tag.
					eXml 
						do: [ :docAtr | 
							| element |
							element := self getBaseElement fromXMLDescription: docAtr.
							element fileName: aFile fullPath basename.
							element fullPath: aFile fullName.
							BPLog f:' new element was create,name:',element fileName.
							self addElement: element ] ] ].
		]
		on:Error
		do:[ :e |  BPLog f: ('Error Parsing file', (aFile fullPath asString),'ERROR:',e asString  ) ].! !

!A4BPAbstractParser methodsFor: 'parser' stamp: 'AlvaroJosePeraltaOcampo 11/11/2014 18:48'!
parseStream: stream
	"base on stream object the stream create BPObjets to represent the xml in memory"

	| document eXml |
	"Start creating a XMLDOM Object from stream"
	
	"document := (XMLDOMParser on: stream) parseDocument."
	document := self getDocumentBaseOnStream: stream. 
	self lstOfTag
		do: [ :tag | 
			eXml := document allElementsNamed: tag.
			eXml do: [ :docAtr | self addElement: (self getBaseElement fromXMLDescription: docAtr) ] ]! !

!A4BPAbstractParser methodsFor: 'parser' stamp: 'AlvaroJosePeraltaOcampo 11/11/2014 18:48'!
parseString: string
	^ self parseStream:  (ReadStream on: string)! !

Object subclass: #A4BPParserTagsXMLRef
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'A4BP-core-parser'!

A4BPParserTagsXMLRef class
	instanceVariableNames: 'tags'!

A4BPParserTagsXMLRef class
	instanceVariableNames: 'tags'!

!A4BPParserTagsXMLRef class methodsFor: 'atr' stamp: 'AlvaroJosePeraltaOcampo 11/18/2014 23:58'!
atrElement
^ 'element'! !

!A4BPParserTagsXMLRef class methodsFor: 'atr' stamp: 'AlvaroJosePeraltaOcampo 11/18/2014 23:58'!
atrInputVariable
^ 'inputVariable'! !

!A4BPParserTagsXMLRef class methodsFor: 'atr' stamp: 'AlvaroJosePeraltaOcampo 11/18/2014 23:58'!
atrMessageType
	^ 'messageType'! !

!A4BPParserTagsXMLRef class methodsFor: 'atr' stamp: 'AlvaroJosePeraltaOcampo 11/18/2014 23:58'!
atrMyRole
^ 'myRole'! !

!A4BPParserTagsXMLRef class methodsFor: 'atr' stamp: 'AlvaroJosePeraltaOcampo 11/18/2014 23:58'!
atrName
^ 'name'! !

!A4BPParserTagsXMLRef class methodsFor: 'atr' stamp: 'AlvaroJosePeraltaOcampo 11/18/2014 23:58'!
atrNamespace
	^ 'namespace'! !

!A4BPParserTagsXMLRef class methodsFor: 'atr' stamp: 'AlvaroJosePeraltaOcampo 11/18/2014 23:58'!
atrOperation
^ 'operation'! !

!A4BPParserTagsXMLRef class methodsFor: 'atr' stamp: 'AlvaroJosePeraltaOcampo 11/18/2014 23:58'!
atrOutputVariable
^ 'outputVariable'! !

!A4BPParserTagsXMLRef class methodsFor: 'atr' stamp: 'AlvaroJosePeraltaOcampo 11/18/2014 23:58'!
atrPartnerLink
^ 'partnerLink'! !

!A4BPParserTagsXMLRef class methodsFor: 'atr' stamp: 'AlvaroJosePeraltaOcampo 11/18/2014 23:58'!
atrPartnerLinkType
^ 'partnerLinkType'! !

!A4BPParserTagsXMLRef class methodsFor: 'atr' stamp: 'AlvaroJosePeraltaOcampo 11/18/2014 23:58'!
atrPartnerRole
^ 'partnerRole'! !

!A4BPParserTagsXMLRef class methodsFor: 'atr' stamp: 'AlvaroJosePeraltaOcampo 11/18/2014 23:58'!
atrPortType
^ 'portType'! !

!A4BPParserTagsXMLRef class methodsFor: 'atr' stamp: 'AlvaroJosePeraltaOcampo 11/18/2014 23:58'!
atrSchemaLocation
	^ 'schemaLocation'! !

!A4BPParserTagsXMLRef class methodsFor: 'atr' stamp: 'AlvaroJosePeraltaOcampo 11/18/2014 23:58'!
atrTargetNamespace
^ 'targetNamespace'! !

!A4BPParserTagsXMLRef class methodsFor: 'atr' stamp: 'AlvaroJosePeraltaOcampo 11/18/2014 23:58'!
atrType
^ 'type'! !

!A4BPParserTagsXMLRef class methodsFor: 'atr' stamp: 'AlvaroJosePeraltaOcampo 11/18/2014 23:58'!
atrVariable
^ 'variable'! !

!A4BPParserTagsXMLRef class methodsFor: 'atr' stamp: 'AlvaroJosePeraltaOcampo 11/18/2014 23:58'!
atrmessageType
	^ 'messageType'! !

!A4BPParserTagsXMLRef class methodsFor: 'factory' stamp: 'AlvaroJosePeraltaOcampo 11/18/2014 23:58'!
fillTags! !

!A4BPParserTagsXMLRef class methodsFor: 'factory' stamp: 'AlvaroJosePeraltaOcampo 11/19/2014 00:30'!
getClassBPBaseOnTypeName: aTypeName
	[ ^ self lstOfBPTagClass  at: aTypeName ]
		on: KeyNotFound
		do: [ ^ self lstOfBPTagClass at:'A4BPEmptyObj']! !

!A4BPParserTagsXMLRef class methodsFor: 'factory' stamp: 'AlvaroJosePeraltaOcampo 11/19/2014 00:31'!
getRef: aModel
	^ aModel accept: self! !

!A4BPParserTagsXMLRef class methodsFor: 'factory' stamp: 'AlvaroJosePeraltaOcampo 11/18/2014 23:58'!
lstOfBPTagClass
	tags ifNil: [ tags := Dictionary new ].
	tags size > 0
		ifTrue: [ ^ tags ].
	self setEmptyObj: tags.
	self fillTags.
	^ tags! !

!A4BPParserTagsXMLRef class methodsFor: 'resetting' stamp: 'AlvaroJosePeraltaOcampo 11/18/2014 23:58'!
reset
	"self reset"
	tags := nil.
	BPParserBPELTagsXMLRef reset.
	BPParserWSDLTagsXMLRef reset.
	BPParserXSDTagsXMLRef reset.
	^ 'OK'! !

!A4BPParserTagsXMLRef class methodsFor: 'factory' stamp: 'AlvaroJosePeraltaOcampo 11/19/2014 00:31'!
setEmptyObj: items
	items add: (BPParserRefTagClass getRefOnTag: 'A4BPEmptyObj' objClass: A4BPEmptyObj).
	^ items! !

!A4BPParserTagsXMLRef class methodsFor: 'tag' stamp: 'AlvaroJosePeraltaOcampo 11/18/2014 23:58'!
tagFaultHandlers
	^ 'faultHandlers'! !

!A4BPParserTagsXMLRef class methodsFor: 'tag' stamp: 'AlvaroJosePeraltaOcampo 11/18/2014 23:58'!
tagInvoke
^ 'invoke'! !

!A4BPParserTagsXMLRef class methodsFor: 'tag' stamp: 'AlvaroJosePeraltaOcampo 11/18/2014 23:58'!
tagProcess
^ 'process'! !

!A4BPParserTagsXMLRef class methodsFor: 'tag' stamp: 'AlvaroJosePeraltaOcampo 11/18/2014 23:58'!
tagVariable
^ 'variable'! !

!A4BPParserTagsXMLRef class methodsFor: 'tag' stamp: 'AlvaroJosePeraltaOcampo 11/18/2014 23:58'!
tagVariables
^ 'variables'! !

!A4BPParserTagsXMLRef class methodsFor: 'visitor' stamp: 'AlvaroJosePeraltaOcampo 11/18/2014 23:58'!
visitBPBPELObject: aModel
	 ^ BPParserBPELTagsXMLRef! !

!A4BPParserTagsXMLRef class methodsFor: 'visitor' stamp: 'AlvaroJosePeraltaOcampo 11/18/2014 23:58'!
visitBPWSDLObject: aModel
	^ BPParserWSDLTagsXMLRef! !

!A4BPParserTagsXMLRef class methodsFor: 'visitor' stamp: 'AlvaroJosePeraltaOcampo 11/18/2014 23:58'!
visitBPXSDObject: aModel
	^ BPParserXSDTagsXMLRef! !
